# CfnChannel

Resource Type definition for AWS::Kinesis::Channel.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnChannel
Implements: IInspectable, ITaggableV2, IEnvironmentAware, IChannelRef, IConstruct, IDependable

- CloudFormation: [`AWS::Kinesis::Channel`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-kinesis-channel.html)
- Source: Generated code
- Type last changed: v2.272.0 · 30 Sep 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_kinesis as kinesis } from 'aws-cdk-lib';
const cfnChannel = new kinesis.CfnChannel(this, 'MyCfnChannel', {
  channelName: 'channelName',
  serviceExecutionRoleArn: 'serviceExecutionRoleArn',
  streamConfigurationList: [{
    recordConfiguration: {
      recordFormatType: 'recordFormatType',

      // the properties below are optional
      gsrSchemaArn: 'gsrSchemaArn',
    },
    streamArn: 'streamArn',
  }],

  // the properties below are optional
  encryptionConfiguration: {
    encryptionType: 'encryptionType',
    keyId: 'keyId',
  },
  loggingConfiguration: {
    cloudWatchLogs: {
      enabled: false,

      // the properties below are optional
      logGroupName: 'logGroupName',
      logStreamName: 'logStreamName',
    },
  },
  s3DestinationConfiguration: {
    storageConfiguration: {
      bucketArn: 'bucketArn',
      compressionType: 'compressionType',
      expectedBucketOwner: 'expectedBucketOwner',

      // the properties below are optional
      outputKeyTemplate: 'outputKeyTemplate',
      storageClass: 'storageClass',
    },

    // the properties below are optional
    dataFreshnessInSeconds: 123,
    deadLetterQueueS3Configuration: {
      bucketArn: 'bucketArn',
      expectedBucketOwner: 'expectedBucketOwner',

      // the properties below are optional
      errorOutputPrefix: 'errorOutputPrefix',
    },
  },
  s3TablesDestinationConfiguration: {
    deadLetterQueueS3Configuration: {
      bucketArn: 'bucketArn',
      expectedBucketOwner: 'expectedBucketOwner',

      // the properties below are optional
      errorOutputPrefix: 'errorOutputPrefix',
    },
    s3TablesConfigurationList: [{
      compressionType: 'compressionType',
      namespace: 'namespace',
      tableBucketArn: 'tableBucketArn',
      tableName: 'tableName',

      // the properties below are optional
      partitionSpec: {
        partitionFields: [{
          sourceName: 'sourceName',
          transform: 'transform',
        }],
      },
    }],

    // the properties below are optional
    dataFreshnessInSeconds: 123,
  },
  tags: [{
    key: 'key',
    value: 'value',
  }],
});
```

## Initializer

```ts
new CfnChannel(scope: Construct, id: string, props: CfnChannelProps)
```

## Construct Props

- `channelName`: string (required) — The name of the channel.

  The name's uniqueness is scoped per AWS account and region.

- `encryptionConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnChannel.EncryptionConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_kinesis.CfnChannel.EncryptionConfigurationProperty.html) — Server-side encryption configuration for data at rest in the destination.

  Data delivered to S3 / S3 Tables is encrypted with the same key.

- `loggingConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnChannel.LoggingConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_kinesis.CfnChannel.LoggingConfigurationProperty.html) — Configuration for delivering channel operational logs.

- `s3DestinationConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnChannel.S3DestinationConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_kinesis.CfnChannel.S3DestinationConfigurationProperty.html) — Configuration for delivery to a vanilla S3 bucket destination.

  Exactly one of S3DestinationConfiguration and S3TablesDestinationConfiguration must be specified on the channel.

- `s3TablesDestinationConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnChannel.S3TablesDestinationConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_kinesis.CfnChannel.S3TablesDestinationConfigurationProperty.html) — Configuration for delivery to S3 Tables destinations.

  Exactly one of S3DestinationConfiguration and S3TablesDestinationConfiguration must be specified on the channel.

- `serviceExecutionRoleArn`: string (required) — The ARN of the IAM role that the channel assumes to read from the source stream, deliver records to the destination, and (when enabled) write CloudWatch Logs.

- `streamConfigurationList`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnChannel.StreamConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_kinesis.CfnChannel.StreamConfigurationProperty.html)[] (required) — List of stream configurations associated with the channel.

  v1 supports a single element; the list shape allows future extensibility to fan in from multiple streams.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — An arbitrary set of tags (key-value pairs) to associate with the Kinesis channel.

## Properties

- `attrChannelArn`: string (required) — The ARN of the channel.

- `attrChannelCreationTimestamp`: string (required) — Timestamp of when the channel was created.

- `attrChannelId`: string (required) — The service-generated unique identifier for the channel.

- `attrChannelStatus`: string (required) — The status of the channel.

- `cdkTagManager`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) (required) — Tag Manager which manages the tags for this resource.

- `CFN_RESOURCE_TYPE_NAME`: string (required) (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) (required) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string (required) — AWS resource type.

- `channelName`: string (required) — The name of the channel.

- `channelRef`: [ChannelReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_kinesis.ChannelReference.html) (required) — A reference to a Channel resource.

- `creationStack`: string[] (required)

- `encryptionConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnChannel.EncryptionConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_kinesis.CfnChannel.EncryptionConfigurationProperty.html) — Server-side encryption configuration for data at rest in the destination.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html) (required)

- `loggingConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnChannel.LoggingConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_kinesis.CfnChannel.LoggingConfigurationProperty.html) — Configuration for delivering channel operational logs.

- `logicalId`: string (required) — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) (required) — The tree node.

- `ref`: string (required) — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `s3DestinationConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnChannel.S3DestinationConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_kinesis.CfnChannel.S3DestinationConfigurationProperty.html) — Configuration for delivery to a vanilla S3 bucket destination.

- `s3TablesDestinationConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnChannel.S3TablesDestinationConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_kinesis.CfnChannel.S3TablesDestinationConfigurationProperty.html) — Configuration for delivery to S3 Tables destinations.

- `serviceExecutionRoleArn`: string (required) — The ARN of the IAM role that the channel assumes to read from the source stream, deliver records to the destination, and (when enabled) write CloudWatch Logs.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) (required) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `streamConfigurationList`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnChannel.StreamConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_kinesis.CfnChannel.StreamConfigurationProperty.html)[] (required) — List of stream configurations associated with the channel.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — An arbitrary set of tags (key-value pairs) to associate with the Kinesis channel.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForChannel(resource: IChannelRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnChannel(x: any): boolean` (static) — Checks whether the given object is a CfnChannel.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
